Imports CompassSample.Model
Imports GalaSoft.MvvmLight.Ioc
Imports Microsoft.Practices.ServiceLocation

Namespace CompassSample.ViewModel
	Public Class ViewModelLocator
		Public Sub New()
			ServiceLocator.SetLocatorProvider(Function() SimpleIoc.Default)

			SimpleIoc.Default.Register(Of ISensorService, SensorService)()
			SimpleIoc.Default.Register(Of MainViewModel)()
		End Sub

		Public ReadOnly Property Main() As MainViewModel
			Get
				Return ServiceLocator.Current.GetInstance(Of MainViewModel)()
			End Get
		End Property

		Public Shared Sub Cleanup()
			' TODO Clear the ViewModels
		End Sub
	End Class
End Namespace
