Imports System
Imports System.Threading
Imports System.Windows

Namespace SimpleMultithreading
	Partial Public Class MainWindow
		Private _condition As Boolean = True

		Public Sub New()
			InitializeComponent()

		End Sub

		Private Sub StartCrashClick(ByVal sender As Object, ByVal e As RoutedEventArgs)
			Dim loopIndex = 0

					' This is a background operation!
						' Do something
						' Notify user
						' Sleep for a while
			ThreadPool.QueueUserWorkItem(Sub(o)
				Do While _condition
					StatusTextBlock.Text = String.Format("Loop # {0}", loopIndex)
					loopIndex += 1
					Thread.Sleep(500)
				Loop
			End Sub)
		End Sub

		Private Sub StartSuccessClick(ByVal sender As Object, ByVal e As RoutedEventArgs)
			Dim loopIndex = 0

					' This is a background operation!
						' Do something
								' Notify user
						' Sleep for a while
            ThreadPool.QueueUserWorkItem(Sub(o)
                                             Do While _condition
                                                 Dispatcher.BeginInvoke((Sub()
                                                                             StatusTextBlock.Text = String.Format("Loop # {0}", loopIndex)
                                                                             loopIndex += 1
                                                                         End Sub))
                                                 Thread.Sleep(500)
                                             Loop
                                         End Sub)
		End Sub
	End Class
End Namespace
